/** @file Cursor.h
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CCursor
 *
 *
 * \brief Objekt kurzor
 *
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef CURSOR_H_
#define CURSOR_H_

#include "GameObject2D.h"

class CCursor : public CGameObject2D{
public:
	CCursor();
	virtual ~CCursor();

	/**
	 * Aktualizuje kurzor
	 */
	void update(){};

	/**
	 * Vykreslí kurzoru
	 */
	void render();

	/**
	 * Zachytí událost pohybu myši
	 * @param x
	 * @param y
	 */
	void mouseMove( int x, int y ){
		this->setPosition(x, y);
	};

};

#endif /* CURSOR_H_ */
