#include "Font.h"

CFont::CFont(){
}

CFont::CFont( const char *fileName, unsigned int size ){
	loadFont(fileName, size);
}

CFont::~CFont(){
	clean();
}

/** Uvolneni prostredku
 */

void CFont::clean(){
	glDeleteLists( listBase, 128 );
	glDeleteTextures( 128, textures );

	delete [] textures;
}

void CFont::print( float x, float y, string str){
	print( x, y, str.c_str());
}

void CFont::print( float x, float y, const char *ftm, ... ){

	pushScreenCoordinateMatrix();

	GLuint font = listBase;
	float h = height / .63f;

	char text[256];
	va_list ap;

	if(ftm == NULL){
		*text = 0;
	}else{

		va_start( ap, ftm );
		vsprintf( text, ftm, ap);
		va_end(ap);

	}

	const char *startLine = text;

	vector<string> lines;

	const char *c = text;

	for( c ; *c; c++ ){
		if( *c == '\n' ){
			string line;
			for( const char *n = startLine; n < c; n++ )
				line.append( 1, *n );
			lines.push_back( line );
			startLine = c + 1;
		}
	}

	if( startLine ){

		string line;
		for( const char *n = startLine; n < c; n++ ){
			line . append(1, *n);
		}

		lines.push_back( line );

	}

	glPushAttrib( GL_LIST_BIT | GL_CURRENT_BIT | GL_ENABLE_BIT | GL_TRANSFORM_BIT );
	glMatrixMode(GL_MODELVIEW);
	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);

	glEnable(GL_BLEND);										// blending mode - pruhlednost
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );	// blendin

	glListBase( font );


	// show that shit
	float modelViewMatrix [16];

	glGetFloatv( GL_MODELVIEW_MATRIX, modelViewMatrix);

	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);

	for( unsigned int i = 0; i < lines . size(); i++ ){

		glPushMatrix();
		glLoadIdentity();
		glTranslatef(x, viewport[3] - y - height - h * i, 0 );
		glMultMatrixf(modelViewMatrix);
		glColor4f( getRed(), getGreen(), getBlue(), getAlpha() );
		glCallLists( lines[i].length(), GL_UNSIGNED_BYTE, lines[ i ] . c_str() );
		glPopMatrix();

	}

	glPopAttrib();

	popProjectionMatrix();

}








