/*
 * FontPrinter.cpp
 *
 *  Created on: May 21, 2011
 *      Author: franta
 */

#include "FontPrinter.h"

CFontPrinter::CFontPrinter() {
	// TODO Auto-generated constructor stub
	m_activeFontID = -1;
	m_fontManager = NULL;
}

CFontPrinter::~CFontPrinter() {
	// TODO Auto-generated destructor stub

}

/**
 * Vypíše řetězec na pozici [x,y]
 * @param x
 * @param y
 * @param string
 */
void CFontPrinter::print(GLfloat x, GLfloat y, const char *str) {
	if (isSetFont()) {
		if (m_fontManager != NULL) {
			m_fontManager->get(getActiveFont()) ->print(x, y, str);
		}
	}
}

/**
 * Vypíše danou barvou řetězec na pozici [x,y]
 * @param x
 * @param y
 * @param color
 * @param string
 */
void CFontPrinter::print(GLfloat x, GLfloat y, Color4f color, const char *str) {
	if ( isSetFont() && m_fontManager != NULL) {
		m_fontManager->get(getActiveFont()) ->setColor(color); // nastaveni barvy pisma
		print(x, y, str); // vypsani retezce
	}
}

/**
 * Vypíše řetězec na pozici [x,y]
 * @param x
 * @param y
 * @param string
 */
void CFontPrinter::print(GLfloat x, GLfloat y, string str) {
		if ( isSetFont() && m_fontManager != NULL) {
			m_fontManager->get(getActiveFont()) ->print(x, y, str.c_str());
		}
}

/**
 * Vypíše danou barvou řetězec na pozici [x,y]
 * @param x
 * @param y
 * @param color
 * @param string
 */
void CFontPrinter::print(GLfloat x, GLfloat y, Color4f color, string str) {
	if (m_fontManager != NULL && isSetFont() ) {
		m_fontManager->get(getActiveFont()) ->setColor(color); // nastaveni barvy pisma
		print(x, y, str.c_str()); // vypsani retezce
	}
}

/**
 * Nastaví aktivní font pro vykreslování
 * @param fontID
 */
void CFontPrinter::activeFont(int fontID) {

	if (m_fontManager != NULL) {

		if ( m_fontManager->get(fontID) != NULL) {
			m_activeFontID = fontID;
		}else{
			if( m_fontManager->size() > 0 ){
				if( m_fontManager->get(0) != NULL ){
					m_activeFontID = 0;
				}
			}
		}
	}
}

void CFontPrinter::print( int fontId, GLfloat x, GLfloat y, Color4f color, const char *str ){
	this->activeFont(fontId);
	print(x, y, color, str);
}

void CFontPrinter::print( int fontId, GLfloat x, GLfloat y, Color4f color, string str ){
	this->activeFont(fontId);
	print(x, y, color, str);
}
