/** @file FontPrinter.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CFontPrinter
 *
 *
 * \brief Vykreslovač písma
 *
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CFONTPRINTER_H_
#define _CFONTPRINTER_H_

#include "main.h"
#include "Singleton.h"
#include "FontManager.h"

class CFontPrinter: public CSingleton<CFontPrinter> {

public:
	CFontPrinter();
	virtual ~CFontPrinter();

	void print(GLfloat x, GLfloat y, string str);
	void print(GLfloat x, GLfloat y, const char *str);
	void print(GLfloat x, GLfloat y, Color4f color, string str);
	void print(GLfloat x, GLfloat y, Color4f color, const char *str);
	void print(int fontId, GLfloat x, GLfloat y, Color4f color, string str);
	void
			print(int fontId, GLfloat x, GLfloat y, Color4f color,
					const char *str);

	void setFontManager(CFontManager* ptrFontManager) {
		m_fontManager = ptrFontManager;
	}
	;
	void activeFont(int fontId);

	int getActiveFont() {
		return m_activeFontID;
	}
	;
	bool isSetFont() {
		return m_activeFontID >= 0 ? true : false;
	}
	;

protected:
	CFontManager* m_fontManager;
	int m_activeFontID;

};

#endif /* FONTPRINTER_H_ */
