/** @file GUIForm.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGUIForm
 *
 *
 * \brief GUI formulář
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CGUIFORM_
#define _CGUIFORM_

#include "GUIFrame.h"

template<class T>
class CGUIForm: public CGUIFrame {

public:

	CGUIForm(T* _instance);

protected:

	void callOnConfirm();

	T* m_instance;
	void (T::*m_funcOnConfirm)(void);
};

template<class T>
CGUIForm<T>::CGUIForm(T* _instance) {
	m_instance = _instance;
	m_funcOnConfirm = NULL;
}

template<class T>
void CGUIForm<T>::callOnConfirm() {
	if (m_instance != NULL && m_funcOnConfirm != NULL) {
		(this->m_instance->*m_funcOnConfirm)();
	}
}

#endif
