/*
 * CGUIFrame.cpp
 *
 *  Created on: May 27, 2011
 *      Author: franta
 */

#include "GUIFrame.h"

CGUIFrame::CGUIFrame() {
	// TODO Auto-generated constructor stub
	this->setBackgroundColor(0,0,0,128);
	this->setBackgroundHoverColor(255, 0,0,255);
	m_paddingLeft = 10;
	m_paddingTop = 10;
	m_lineHeight = 22;
}

CGUIFrame::~CGUIFrame() {
	// TODO Auto-generated destructor stub
}

void CGUIFrame::render() {

	glPushMatrix();

	glTranslatef(getPositionX(), getPositionY(), 0);

	Color4f backgroundColor = this->getCurrentBackgroundColor();

	glColor4f(backgroundColor.r, backgroundColor.g, backgroundColor.b,
			backgroundColor.alpha);

	glBegin(GL_QUADS);
	glVertex2f(0, 0);
	glVertex2f(getWidth(), 0);
	glVertex2f(getWidth(), getHeight());
	glVertex2f(0, getHeight());
	glEnd();

	glPopMatrix();

	CGameObject2D* curr = NULL;

	for (int i = 0; i < this->size(); i++) {
		if ((curr = get(i)) != NULL) {
			curr->render();
		}
	}

}

void CGUIFrame::update() {

	if (isVisible()) {
		CGameObject2D* curr = NULL;

		for (int i = 0; i < this->size(); i++) {
			if ((curr = get(i)) != NULL) {
				curr->update();
			}
		}
	}
}

void CGUIFrame::mouseMove(int x, int y) {

	CGameObject2D* curr = NULL;

	for (int i = 0; i < this->size(); i++) {
		if ((curr = get(i)) != NULL) {
			curr->mouseMove(x, y);
		}
	}

}

void CGUIFrame::mouseButtons(int button, int state, int x, int y) {
	CGameObject2D* curr = NULL;

	if (isVisible()) {
		for (int i = 0; i < this->size(); i++) {
			if ((curr = get(i)) != NULL) {

				curr->mouseButtons(button, state, x, y);
			}
		}
	}

}

void CGUIFrame::keyboard(unsigned char key, int x, int y) {

	CGameObject2D* curr = NULL;

	cout << "FRAME" << endl;

	for (int i = 0; i < this->size(); i++) {
		if ((curr = get(i)) != NULL) {
			curr->keyboard(key, x, y);
		}
	}

}

/**
 * Nastaví pozici rámce
 * @param x
 * @param y
 */
void CGUIFrame::setPosition(float x, float y) {
	CGUIElement::setPosition(x, y);
	repositionChilds(x, y);
}

/**
 * Přepočítá pozice dceřiných prvků
 * @param x
 * @param y
 */
void CGUIFrame::repositionChilds(float x, float y) {
	if (size() > 0) {
		for (int i = 0; i < size(); i++) {
			repositionChild(i, x, y);
		}
	}
}

/**
 * Přepočítá pozici dceřiného prvku
 * @param index
 * @param x
 * @param y
 */
void CGUIFrame::repositionChild(int index, float x, float y) {
	if (index >= 0 && index < size()) {
		CGameObject2D* curr = NULL;
		if ((curr = get(index)) != NULL) {
			curr->setPosition( getPaddingLeft() + getPositionX(), getPaddingTop() + getPositionY() + index * getLineHeight());
		}
	}
}

/**
 * Přidá nový prvek
 * @param child
 */

void CGUIFrame::addChild(CGUIElement* child) {
	add(child);
	repositionChild(size() - 1, getPositionX(), getPositionY());
}

bool CGUIFrame::removeChild(int index) {
	return CCollection<CGUIElement>::remove(index);
}

CGUIElement* CGUIFrame::getChild(int index) {
	return CCollection<CGUIElement>::get(index);
}
