/** @file GUIFrame.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGUIFrame
 *
 *
 * \brief Obdoba GUI formuláře
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef CGUIFRAME_H_
#define CGUIFRAME_H_

#include "GameObject2D.h"
#include "GUIElement.h"
#include "Collection.h"

#include "GUIButton.h"
#include "GUIImage.h"
#include "GUILabel.h"

class CGUIFrame: protected CCollection<CGUIElement> , public CGUIElement {

public:

	CGUIFrame();
	virtual ~CGUIFrame();

	/**
	 * Vykreslí prvky ramce
	 */
	virtual void render();

	/**
	 * Aktualizuje prvky rámce
	 */
	void update();

	// eventy

	/**
	 * Pošle zprávu o pohybu myši prvkům rámce
	 * @param x
	 * @param y
	 */
	void mouseMove(int x, int y);

	/**
	 * Pošle zprávu o stistknutí tlačítka myši prvkům rámce
	 * @param button
	 * @param state
	 * @param x
	 * @param y
	 */
	void mouseButtons(int button, int state, int x, int y);

	void keyboard(unsigned char key, int x, int y);

	void repositionChilds(float x, float y);
	void repositionChild(int index, float x, float y);
	void setPosition(float x, float y);

	void addChild(CGUIElement* child);
	void addChildAtPosition(CGUIElement*);
	CGUIElement* getChild(int index);
	bool removeChild(int index);

	/**
	 * Vycentruje rámec a prvky v něm
	 */

	virtual void centered() = 0;

private:

};

#endif /* CGUIFRAME_H_ */
