/*
 * GUIInput.cpp
 *
 *  Created on: May 20, 2011
 *      Author: František Toman
 */

#include "GUIInput.h"

/**
 * Konstruktor
 */
CGUIInput::CGUIInput() {
	disableEdit();

	this->setBackgroundColor(0, 0, 0, 0);
	this->setBackgroundHoverColor(0, 0, 0, 0);
	this->setTextColor(255, 255, 255, 255);
	this->setTextHoverColor(100, 100, 100, 255);

	m_maxChars = -1;

}

/**
 * Destruktor
 */
CGUIInput::~CGUIInput() {

}

/**
 * Vykreslení objektu
 */
void CGUIInput::render() {

	glPushMatrix();
	glLoadIdentity();
	glTranslatef(getPositionX(), getPositionY(), 0);

	Color4f backgroundColor = this->getCurrentBackgroundColor();

	glColor4f(backgroundColor.r, backgroundColor.g, backgroundColor.b,
			backgroundColor.alpha);

	glBegin(GL_QUADS);
	glVertex2f(0, 0);
	glVertex2f(getWidth(), 0);
	glVertex2f(getWidth(), getHeight());
	glVertex2f(0, getHeight());
	glEnd();

	glPopMatrix();
	// vykresleni obsah

	CFontManager::getInstance()->get(0)->print(this->getPositionX(),
			getPositionY(), getString());

}

/**
 * Aktualizace objektu
 */
void CGUIInput::update() {

}

/**
 * Zachytávání vstupu z klávesnice
 * @param key
 * @param x
 * @param y
 */
void CGUIInput::keyboard(unsigned char key, int x, int y) {

	if (editable()) {
		// smazani posledniho znaku
		if (key == 8) {
			this->removeLastChar();
		} else {
			if (m_maxChars == -1 || m_maxChars > this->length()) {
				// pridani dalsiho znaku
				this->append((char) key);
			}
		}
	}

}

/**
 * Zachytávání stisku tlačítek myši
 * @param button
 * @param state
 * @param x
 * @param y
 */
void CGUIInput::mouseButtons(int button, int state, int x, int y) {

	if (state == GLUT_DOWN) {
		if (isHover()) {
			enableEdit();
		} else {
			disableEdit();
		}
	}

}

/**
 * Je ukazatel kurzoru nad objektem?
 * @return
 */
bool CGUIInput::isOver() {
	return true;
}

