/** @file GUIInput.h
 *
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CGUIInput
 *
 *
 * \brief GUI vstup
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CGUIINPUT_H_
#define _CGUIINPUT_H_

#include "GUIElement.h"

class CGUIInput : public CGUIElement {
public:
	CGUIInput();
	virtual ~CGUIInput();

	void render();
	void update();

	void setEdited( bool edited ){
		m_edited = edited;
	}

	void enableEdit(){ m_edited = true; };
	void disableEdit(){ m_edited = false; };
	bool editable(){ return m_edited; }

	// akce

	//void mouseMove( int x, int y );
	void keyboard( unsigned char key, int x, int y);
	void mouseButtons( int button, int state, int x, int y );

	// pomocne funkce akci
	bool isOver();

	void setMaxChars( int count ){ m_maxChars = count; };

protected:
	bool m_edited;
	int	 m_maxChars;

};

#endif /* _CGUIINPUT_H_ */
