/** @file GUIPrompt.h
 *
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CGUIPrompt
 *
 *
 * \brief GUI výzva - vstup
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef GUIPROMPT_H_
#define GUIPROMPT_H_

#include "GUIConfirm.h"

template <class T>
class CGUIPrompt : public CGUIConfirm<T>{

public:
	CGUIPrompt();
	virtual ~CGUIPrompt();

	virtual void	initChilds();
	virtual string	getResult();

	void	setMaxChars( int count );

};

template <class T>
CGUIPrompt<T>::CGUIPrompt() {

}

template <class T>
CGUIPrompt<T>::~CGUIPrompt() {
	// TODO Auto-generated destructor stub
}

template <class T>
void CGUIPrompt<T>::initChilds(){

		CGUILabel* text = new CGUILabel();

		CGUIButton<CGUIPrompt> *buttonOK = new CGUIButton<CGUIPrompt> (this);
		buttonOK->setMouseDownCallback(&CGUIPrompt::onConfirm);
		buttonOK->setString("OK");
		buttonOK->setDimension(25, 14);

		CGUIButton<CGUIPrompt> *buttonCancel = new CGUIButton<CGUIPrompt> (this);
		buttonCancel->setMouseDownCallback(&CGUIPrompt::onCancel);
		buttonCancel->setString("CANCEL");
		buttonCancel->setDimension(50, 14);

		CGUIInput*	input = new CGUIInput();
		input->setDimension(86,14);
		input->setBackgroundColor(255,255,255, 50);

		this->addChild(text);
		this->addChild(input);
		this->addChild(buttonOK);
		this->addChild(buttonCancel);

}

template<class T>
string CGUIPrompt<T>::getResult(){
	CGUIElement*	input = NULL;
	if( ( input = this->getChild(1) ) != NULL ){

		string str = input->getString();
		input->setString("");

		return str;
	}

	return NULL;
}

template<class T>
void CGUIPrompt<T>::setMaxChars( int count ){
	CGUIElement* vstup = this->getChild(1);
	if( vstup != NULL ){
		dynamic_cast<CGUIInput*>(vstup)->setMaxChars(count);
	}
}


#endif /* GUIPROMPT_H_ */
