/** @file GameObject.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGameObject
 *
 *
 * \brief Herní objekt
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef GAMEOBJECT_H_
#define GAMEOBJECT_H_

#include "Textureable.h"
#include "Colorable.h"
#include "Renderable.h"
#include "Updateable.h"
#include "Mouseable.h"
#include "KeyListener.h"

#include "TextureManager.h"

class CGameObject: public CRenderable,
		public CTextureable,
		public CUpdateable,
		public CMouseable,
		public CKeyListener,
		public CColorable {
public:
	CGameObject();
	virtual ~CGameObject();

	bool isVisible() {
		return m_visible;
	}

	void show() {
		m_visible = true;
	}

	void hide() {
		m_visible = false;
	}


	virtual void mouseMove(int x, int y) {
	}

	virtual void mouseButtons(int button, int state, int x, int y) {
	}

	virtual void keyboard(unsigned char key, int x, int y) {
	}

	virtual void keyboardSpecial(int key, int x, int y) {
	}


protected:
	bool m_visible;

};

#endif /* GAMEOBJECT_H_ */
