/** @file GameObject2D.h
*
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CGameObject2D
 *
 *
 * \brief 2D herní objekt
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _GAMEOBJECT2D_H_
#define _GAMEOBJECT2D_H_

#include "GameObject.h"
#include "Positionable2D.h"
#include "Rotationable2D.h"
#include "Sizeable2D.h"

class CGameObject2D : public CGameObject, public CRotationable2D, public CPositionable2D, public CSizeable2D {
public:
	CGameObject2D();
	virtual ~CGameObject2D();
	virtual void render() = 0;

};

#endif /* GAMEOBJECT2D_H_ */
