/** @file GameObject2DManager.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 *
 * \class CGameObject2DManager
 *
 * \brief Správce 2D objektů
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _GAMEOBJECT2DMANAGER_H_
#define _GAMEOBJECT2DMANAGER_H_

#include "Singleton.h"
#include "Collection.h"
#include "GameObject2D.h"
#include "Mouseable.h"
#include "KeyListener.h"

class CGameObject2DManager: public CSingleton<CGameObject2DManager> ,
		public CCollection<CGameObject2D> ,
		public CUpdateable,
		public CMouseable,
		public CKeyListener {
public:
	CGameObject2DManager();
	virtual ~CGameObject2DManager();

	void update();
	void mouseMove(int x, int y);
	void mouseButtons(int button, int state, int x, int y);
	void keyboard(unsigned char key, int x, int y);
	void keyboardSpecial(int key, int x, int y);

};

#endif /* GAMEOBJECT2DMANAGER_H_ */
