/** @file GameObject3D.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGameObject3D
 *
 *
 * \brief 3D herní objekt
 *
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CGOBJECT_H_
#define _CGOBJECT_H_

#include "main.h"
#include "Positionable3D.h"
#include "Rotationable3D.h"
#include "Sizeable3D.h"
#include "GameObject.h"

class CGameObject3D: public CGameObject,
		public CRotationable3D,
		public CPositionable3D,
		public CSizeable3D {

public:
	CGameObject3D(void);
	CGameObject3D(float x, float y, float z);
	CGameObject3D(Position3D position);
	~CGameObject3D(void);

	virtual void render() = 0;

	virtual void beforeRender();
	virtual void afterRender();

protected:

	GLfloat* m_vertexes; // body objektu

};

#endif

