/** @file GameObject3DManager.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGameObject3DManager
 *
 *
 * \brief Správce 3D herních objektů
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CGOMANAGER_H_
#define _CGOMANAGER_H_

#include "GameObject3D.h"
#include "Singleton.h"
#include "Collection.h"

class CGameObject3DManager: public CSingleton<CGameObject3DManager> ,
		public CCollection<CGameObject3D> ,
		public CUpdateable,
		public CMouseable,
		public CKeyListener {

public:
	CGameObject3DManager(void); // 	konstruktor
	~CGameObject3DManager(void); //	destruktor

	void update();

	void mouseMove(int x, int y);
	void mouseButtons(int button, int state, int x, int y);
	void keyboard(unsigned char key, int x, int y);
	void keyboardSpecial(int key, int x, int y);

private:

};

#endif

