#include "GameStateManager.h"

/**
 * Konstruktor
 */
CGameStateManager::CGameStateManager(void) {
	m_currentGameState = NULL;
}

/**
 * Destruktor
 */
CGameStateManager::~CGameStateManager(void) {

}

/**
 * Změna scény hry
 * @param state
 */
void CGameStateManager::switchStateTo(int state) {

	if (state < size()) {
		if( m_currentGameState != NULL ){

			m_currentGameState->clear();
			m_currentGameState = get(state);
			m_currentGameState->init();

		}else{
			m_currentGameState = get(state);
			m_currentGameState->init();
		}
	}

}

void CGameStateManager::render() {
	if( m_currentGameState != NULL ){
		if( m_currentGameState->isRunning() ){
			m_currentGameState->render();
		}
	}
}

void CGameStateManager::update() {

	if( m_currentGameState != NULL ){
		if( m_currentGameState->isRunning() ){
			m_currentGameState->update();
		}else{

			int nextState = m_currentGameState->getNextState();

			cout << "Next state: " << nextState << endl;

			if( nextState >= 0 ){
				cout << "Set next state to: " << nextState << endl;
				switchStateTo( nextState );
			}
		}
	}

}

