/** @file GameStateManager.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CGameStateManager
 *
 *
 * \brief Správce stavů hry
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 *
 */

#ifndef _CGAMESTATEMANAGER_
#define _CGAMESTATEMANAGER_

// hlavicky souboru projektu
#include "GameState.h"
#include "Collection.h"
#include "Updateable.h"
#include "Renderable.h"

class CGameStateManager: public CCollection<CGameState> ,
		public CUpdateable,
		public CRenderable {

public:

	CGameStateManager(void);
	~CGameStateManager(void);

	void update();
	void render();

	void switchStateTo(int state);
	CGameState* getCurrentState() {
		return m_currentGameState;
	}
	;

private:
	CGameState* m_currentGameState;

};

#endif

