/** @file ImageLoader.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CImageLoader
 *
 *
 * \brief Načítač obrázků
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CIMGLOADER_H_
#define _CIMGLOADER_H_

#include "Singleton.h"

class CImageLoader: public CSingleton<CImageLoader> {

public:

	typedef struct ImageInfo {
		int width;
		int height;
		int depth;
		int format;
		ILubyte* data;

		ImageInfo() :
			width(0), height(0), depth(0), format(0), data(NULL) {
		}
		;

	} IMAGEINFO;

	CImageLoader();
	~CImageLoader();

	void clear(void);
	bool loadImage(const char *fileName);
	ImageInfo getInfo();

private:
	ILuint m_data; // data nacteneho obrazku

};

#endif

