#include "LevelLoader.h"
#include <sstream>

CLevelLoader::CLevelLoader() {
	m_width = 0;
	m_length = 0;
	m_mapdata = NULL;
}

CLevelLoader::~CLevelLoader() {
	this->clearMap();
}

bool CLevelLoader::loadLevel(const char * fileName) {

	this->clearMap();

	cout << "Loading level: " << fileName << endl;

	ifstream levelData; // zdroj levelu
	levelData.open(fileName, ios::in); // otevreme zdroj

	string bufferLine;
	string tmp;

	bool mapsize = false;
	bool playerStart = false;

	int tmpLine = 0;

	if (levelData.is_open()) {
		cout << "Level file " << fileName << " is opened ... " << endl;
		while (levelData.good()) {
			getline(levelData, bufferLine);
			istringstream input(bufferLine, istringstream::in);

			// nacteni velikosti levelu
			if (!mapsize) {

				input >> m_width;
				input >> m_length;
				mapsize = true;

				cout << m_width << endl;

				m_mapdata = new int*[m_length];
				for (int i = 0; i < m_length; i++) {
					m_mapdata[i] = new int[m_width];
					for (int j = 0; j < m_width; j++) {
						m_mapdata[i][j] = 0;
					}
				}

				cout << "WL loaded" << endl;

			} else if (!playerStart) {

				input >> m_positionPlayerX;
				input >> m_positionPlayerZ;
				playerStart = true;

			} else {
				// nacteni obsahu levelu

				if (tmpLine < m_length) {

					cout << "BL: " << bufferLine << endl;

					for (int i = 0; i < m_width; i++) {
						input >> m_mapdata[tmpLine][i];
						cout << m_mapdata[tmpLine][i] << ":";
					}

					tmpLine++;
				} else {
					break;
				}
			}

		}
	} else {
		cerr << "File not found " << endl;
		return false;
	}

	cout << "Level size: " << m_width << "x" << m_length << endl;
	cout << "Level data loaded" << endl;

	// nactena data vratime v podobe noveho levelu
	levelData.close(); // uzavreme zdroj

	return true;
}

bool CLevelLoader::loadLevel(int id) {
	string sIdLevel = _toString<int> (id);
	string sFileName("data/levels/");
	sFileName.append(sIdLevel);
	return loadLevel(sFileName.c_str());
}

void CLevelLoader::put(CLevel &level) {
	level.createMap(m_mapdata, m_width, m_length, m_positionPlayerX,
			m_positionPlayerZ);
}

void CLevelLoader::clearMap() {
	if (this->m_mapdata != NULL) {

		cout << "DELETE OLD LEVEL" << endl;

		for (int i = 0; i < m_length; i++) {
			if (m_mapdata[i] != NULL) {
				delete [] m_mapdata[i];
				m_mapdata[i] = NULL;
			}
		}

		delete[] m_mapdata;
		m_mapdata = NULL;
	}
}
