/** @file LevelLoader.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CLevelLoader
 *
 *
 * \brief Načítač map hry
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _HCLEVELLOADER_
#define _HCLEVELLOADER_

#include "Singleton.h"
#include "Level.h"

class CLevelLoader: public CSingleton<CLevelLoader> {

public:

	CLevelLoader();
	virtual ~CLevelLoader();

	bool loadLevel(int id);
	bool loadLevel(const char * fileName);

	int getWidth() {
		return m_width;
	}
	;
	int getLength() {
		return m_length;
	}
	;
	int** getMapData() {
		return m_mapdata;
	}
	;

	int getPositionPlayerX() const {
		return m_positionPlayerX;
	}
	;
	int getPositionPlayerZ() const {
		return m_positionPlayerZ;
	}
	;

	void clearMap();
	void put(CLevel &level);

private:
	int** m_mapdata;
	int m_width;
	int m_length;

	int m_positionPlayerX;
	int m_positionPlayerZ;

};

#endif

