#include "Plane.h"
#include "TextureManager.h"

CGOPlane::CGOPlane() {
	m_width = 0;
	m_width = 0;

	m_vertexes = new GLfloat[12];

	GLfloat vertexes[] = { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0,
			0.0, 1.0 };

	GLfloat texCoord[] = { 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 1.0, };

	for (int i = 0; i < 12; i++) {
		m_vertexes[i] = vertexes[i];
	}

	this->setRotation(0, 0, 0);
	this->setPosition(0, 0, 0);
	this->setDimension(1, 1, 1);

	this->setVertices(texCoord, 48);

}

CGOPlane::CGOPlane(int width, int height, POSITION3D position) {
	m_width = width;
	m_height = height;
}

CGOPlane::~CGOPlane() {
	if (m_vertexes != NULL) {
		delete[] m_vertexes;
	}
}

/** vykreslovaci metoda 
 */
void CGOPlane::render() {

	glPushMatrix(); // ulozime matici na zasobnik

	// posuneme objekt na pozici
	glTranslatef(m_position . x, m_position . y, m_position . z);

	// nastavime rotaci
	if (isRotated()) {
		glRotatef(m_rotation.rotX, 1.0, 0.0, 0.0);
		glRotatef(m_rotation.rotY, 0.0, 1.0, 0.0);
		glRotatef(m_rotation.rotZ, 0.0, 0.0, 1.0);
	}

	// zvetsime objekt na pozadovanou velikost
	glScalef(m_dimension.width, m_dimension.height, m_dimension.length);

	glEnableClientState(GL_VERTEX_ARRAY);
	glColor4f(getRed(), getGreen(), getBlue(), getAlpha());

	if (isTextured() && isSetVertices()) {

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,
				CTextureManager::getInstance()->get(getTextureId())->getID());

		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		glTexCoordPointer(2, GL_FLOAT, 0, m_texCoord);
	}

	glVertexPointer(3, GL_FLOAT, 0, m_vertexes);
	glDrawArrays(GL_QUADS, 0, 4);

	if (this->isTextured() && isSetVertices()) {
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		glDisable(GL_TEXTURE_2D);
	}

	glDisableClientState(GL_VERTEX_ARRAY);

	glPopMatrix();

}
