/** @file Positionable.h
* Hlavičkový soubor Kolekce. Kolekce slouží k ukládání proměnných stejného datového typu.
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CPositionable
 *
 *
 * \brief Šablona třídy kolekce
 *
 * Šablona třídy CCollection (kolekce) umožňuje třídám, jež tuto dědí, ukládat proměnné specifického datového typu.
 *
 * Speciální vlastností této kolekce je možnost nastavení zámku v kolekci. V případě, že je zámek nastaven, pak jsou při vyčištění kolekce smazány pouze prvky,
 * na pozici vyšší než je hodnota zámku.
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef CPOSITIONABLE_H_
#define CPOSITIONABLE_H_

#include "main.h"
#include "structures.h"

template <typename T>
class CPositionable {
public:
	CPositionable();
	void 	setPosition(T position){ m_position = position; };
	T		getPosition() const { return m_position; };

protected:
	T	m_position;

};

template <typename T> CPositionable<T>::CPositionable(){

}

#endif /* POSITIONABLE_H_ */
