/** @file Rotationable2D.h
*
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CRotationable2D
 *
 *
 * \brief Rotace objektu v rovině
 *
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CROTATIONABLE2D_H_
#define _CROTATIONABLE2D_H_

#include "Rotationable.h"

class CRotationable2D : public CRotationable<Rotation2D>{
public:
	CRotationable2D();
	virtual ~CRotationable2D();

	/**
	 * Nastavení rotace
	 * @param rotX
	 * @param rotY
	 */
	void setRotation( float rotX, float rotY){ m_rotation . rotX = rotX; m_rotation . rotY = rotY; };

	/**
	 * Je nastavena nenulová rotace?
	 * @return
	 */
	bool isRotated(){ return m_rotation.rotX == 0 && m_rotation.rotY == 0 ? false : true; };

};

#endif /* _CROTATIONABLE2D_H_ */
