/** @file Rotationable3D.h
 *
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CRotationable3D
 *
 *
 * \brief Rotace objektu v prostoru
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef ROTATIONABLE3D_H_
#define ROTATIONABLE3D_H_

#include "Rotationable.h"

class CRotationable3D : public CRotationable<Rotation3D>{
public:
	CRotationable3D();
	virtual ~CRotationable3D();

	/**
	 * Nastavení rotace
	 * @param rotX
	 * @param rotY
	 * @param rotZ
	 */
	void setRotation( float rotX, float rotY, float rotZ){ m_rotation . rotX = rotX; m_rotation . rotY = rotY; m_rotation . rotZ = rotZ; };

	/**
	 * Je nastavena nenulová rotace?
	 * @return
	 */
	bool isRotated(){ return m_rotation.rotX == 0 && m_rotation.rotY == 0 && m_rotation.rotZ == 0 ? false : true; };

};

#endif /* ROTATIONABLE3D_H_ */
