/** @file Sizeable2D.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CSizeable2D
 *
 *
 * \brief Velikost v rovině
 *
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CSIZEABLE2D_H_
#define _CSIZEABLE2D_H_

#include "Sizeable.h"

class CSizeable2D: public CSizeable<Dimension2D> {
public:
	CSizeable2D();
	virtual ~CSizeable2D();

	/**
	 * Vrátí šířku objektu
	 * @return
	 */
	float getWidth() {
		return m_dimension.width;
	}
	;

	/**
	 * Vrátí výšku objektu
	 * @return
	 */
	float getHeight() {
		return m_dimension.height;
	}
	;

	/**
	 * Nastavení rozměrů 2D objektu
	 * @param width
	 * @param height
	 */
	void setDimension(float width, float height) {
		m_dimension.width = width;
		m_dimension.height = height;
	}
	;

	void setWidth(float width) {
		m_dimension.width = width;
	}
	;
	void setHeight(float height) {
		m_dimension.height = height;
	}
	;

};

#endif /* _CSIZEABLE2D_H_ */
