/** @file Sizeable3D.h
*
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CSizeable3D
 *
 *
 * \brief Velikost v prostoru
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CSIZEABLE3D_H_
#define _CSIZEABLE3D_H_

#include "Sizeable.h"

class CSizeable3D : public CSizeable<Dimension3D>{
public:
	CSizeable3D();
	virtual ~CSizeable3D();

	void setDimension( float width, float height, float length ){
		m_dimension.width = width;
		m_dimension.height = height;
		m_dimension.length = length;
	};

	void setWidth( float width ){ m_dimension.width = width; };
	void setHeight( float height ){ m_dimension.height = height; };
	void setLength( float length ){ m_dimension.length = length; };

	float getWidth (){ return m_dimension.width; };
	float getHeight (){ return m_dimension.height; };
	float getLength (){ return m_dimension.length; };

};

#endif /* _CSIZEABLE3D_H_ */
