/*
 * SokobanGame.cpp
 *
 *  Created on: May 21, 2011
 *      Author: Frantisek Toman
 */

#include "SokobanGame.h"

#include "SokobanSceneIntro.h"
#include "SokobanSceneMenu.h"
#include "SokobanSceneGame.h"

SokobanGame::SokobanGame() {
	cout << "******SOKOBAN GAME CREATED******" << endl;
	this->setTitle("Sokoban 3D");
}

SokobanGame::~SokobanGame() {

}

void SokobanGame::loadFonts(void) {
	CFontManager* fontManager = CFontManager::getInstance();
	fontManager->addFromFile("data/fonts/golong.ttf", 14);					// FONT 0
	fontManager->addFromFile("data/fonts/golong.ttf", 16);					// FONT 1
	fontManager->addFromFile("data/fonts/nn.ttf", 50);						// FONT 2
}

void SokobanGame::loadTextures(void) {

}

void SokobanGame::createScenes() {

	CGameState** scenes = new CGameState*[3];

	for (int i = 0; i < 3; i++) {
		scenes[i] = NULL;
	}

	scenes[0] = new CSokobanSceneIntro();
	scenes[1] = new CSokobanSceneMenu();
	scenes[2] = new CSokobanSceneGame();

	scenes[0]->setNextState(1);
	scenes[1]->setNextState(2);
	scenes[2]->setNextState(1);

	m_gameStateManager->add(scenes, 3);
	m_gameStateManager->switchStateTo(0);

	delete [] scenes;
}
