/*
 * SokobanSceneGame.cpp
 *
 *  Created on: May 21, 2011
 *      Author: franta
 */

#include "SokobanGame.h"
#include "SokobanSceneGame.h"

#include "LevelLoader.h"
#include "GUIConfirm.h"
#include "GUIMessage.h"
#include "Cursor.h"
#include "ProfileManager.h"

CSokobanSceneGame::CSokobanSceneGame() {
	// TODO Auto-generated constructor stub

	/**
	 * Reference:
	 *  	0 - conf zpet do menu
	 *  	1 - conf ukoncit aplikaci
	 *  	2 - conf next level
	 *  	3 - mess konec hry, nebyl nalezen dalsi level
	 *  	4 - menu game
	 *  	5 - kurzor
	 *  	6 - pozadi
	 *  	7 - label skore
	 *  	8 -
	 *  	9 -
	 */

}

CSokobanSceneGame::~CSokobanSceneGame() {
	// TODO Auto-generated destructor stub
}

void CSokobanSceneGame::init() {

	this->m_running = true;
	this->m_nextLevel = false;
	this->m_goToMenu = false;
	m_endOfGame = false;

	this->createObject2DReferences(10);

	cout << "Scene game initialization ... " << endl;

	// ---------------------------------------------------------------------
	// Nastaveni animace

	m_fadeIn = true;
	m_fadeOut = false;
	m_fadesAnimation.reset();
	m_fadesAnimation.setup(true, 0, 255, 5);

	// ---------------------------------------------------------------------
	// ---------------------------------------------------------------------

	// na pozadi tmava pruhledna barva
	CGUIImage* img = new CGUIImage();
	img->setColor(0, 0, 0, 200);
	img->setPosition(0, 0);
	img->setDimension(800, 600);

	this->m_gameObject2DManager->add(img);
	m_referencesObject2D[6] = m_gameObject2DManager->getLastInsertID();

	// -------------------------------------------------------------------------
	// Vytvoření potvrzovacích zpráv

	// zpet do menu

	CGUIConfirm<CSokobanSceneGame>* confBackToMenu = new CGUIConfirm<
			CSokobanSceneGame> ();
	confBackToMenu->initChilds();
	confBackToMenu->setConfirmMessage("REALLY BACK TO MENU?");
	confBackToMenu->setDimension(192, 80);
	confBackToMenu->setCallback(this, &CSokobanSceneGame::resultGoToMenu);
	confBackToMenu->hide();
	confBackToMenu->centered();

	this->m_gameObject2DManager->add(confBackToMenu);
	m_referencesObject2D[0] = m_gameObject2DManager->getLastInsertID();

	// ukoncit aplikaci
	CGUIConfirm<CSokobanSceneGame>* confExitApp = new CGUIConfirm<
			CSokobanSceneGame> ();
	confExitApp->initChilds();
	confExitApp->setConfirmMessage("YOU REALLY WANT TO QUIT?");
	confExitApp->setDimension(226, 80);
	confExitApp->setCallback(this, &CSokobanSceneGame::resultExitApp);
	confExitApp->hide();
	confExitApp->centered();

	this->m_gameObject2DManager->add(confExitApp);
	m_referencesObject2D[1] = m_gameObject2DManager->getLastInsertID();

	// dalsi level
	CGUIConfirm<CSokobanSceneGame>* confNextLevel = new CGUIConfirm<
			CSokobanSceneGame> ();
	confNextLevel->initChilds();
	confNextLevel->setConfirmMessage("NEXT LEVEL? CANCEL = RESET LEVEL");
	confNextLevel->setDimension(300, 80);
	confNextLevel->setCallback(this, &CSokobanSceneGame::resultNextLevel);
	confNextLevel->hide();
	confNextLevel->centered();

	this->m_gameObject2DManager->add(confNextLevel);
	m_referencesObject2D[2] = m_gameObject2DManager->getLastInsertID();

	// konec hry
	CGUIMessage<CSokobanSceneGame>* messEndGame = new CGUIMessage<
			CSokobanSceneGame> ();
	messEndGame->setMessage("KONEC HRY");
	messEndGame->setDimension(100, 80);
	messEndGame->setCallback(this, &CSokobanSceneGame::endGoToMenu);
	messEndGame->hide();
	messEndGame->centered();

	this->m_gameObject2DManager->add(messEndGame);
	m_referencesObject2D[3] = m_gameObject2DManager->getLastInsertID();

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------

	// -------------------------------------------------------------------------
	// Menu hry

	CGUIMenu<CGUIMenuItem<CSokobanSceneGame> >* menu = new CGUIMenu<
			CGUIMenuItem<CSokobanSceneGame> > ;
	menu->hide();

	menu->setDimension(110, 100);

	CGUIMenuItem<CSokobanSceneGame>* miResume = new CGUIMenuItem<
			CSokobanSceneGame> ();
	CGUIMenuItem<CSokobanSceneGame>* miRestart = new CGUIMenuItem<
			CSokobanSceneGame> ();
	CGUIMenuItem<CSokobanSceneGame>* miGoToMenu = new CGUIMenuItem<
			CSokobanSceneGame> ();
	CGUIMenuItem<CSokobanSceneGame>* miQuit = new CGUIMenuItem<
			CSokobanSceneGame> ();

	// pridani do menu
	menu->add(miResume);
	menu->add(miRestart);
	menu->add(miGoToMenu);
	menu->add(miQuit);

	miResume->setString("RESUME");
	miRestart->setString("RESTART");
	miGoToMenu->setString("GO TO MENU");
	miQuit->setString("QUIT");

	miResume->setDimension(100, 20);
	miRestart->setDimension(100, 20);
	miGoToMenu->setDimension(100, 20);
	miQuit->setDimension(100, 20);

	Color4f color;
	color.alpha = 128;
	color.r = 0;
	color.b = 0;
	color.g = 0;
	miResume->setColor(color);
	miRestart->setColor(color);
	miGoToMenu->setColor(color);
	miQuit->setColor(color);

	// nastaveni callbacku menu
	miResume->setCallback(this, &CSokobanSceneGame::resume, NULL);
	miRestart->setCallback(this, &CSokobanSceneGame::restartLevel, NULL);
	miGoToMenu->setCallback(this, &CSokobanSceneGame::requestGoToMenu, NULL);
	miQuit->setCallback(this, &CSokobanSceneGame::requestExitApp, NULL);

	this->m_gameObject2DManager->add(menu);
	m_referencesObject2D[4] = m_gameObject2DManager->getLastInsertID();

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------

	// -------------------------------------------------------------------------
	// Nastavení kamery v menu

	CCamera *camera = CCamera::getInstance();
	camera -> setPosition(10, 10, -51);
	camera -> setTarget(0, 0, 0);
	camera ->setAngle(180);

	GLfloat angle = camera->getAngle();

	camera->setPositionZ(-cos(angle * PI / 180) * 5);
	camera->setPositionX(sin(angle * PI / 180) * 5);

	CRenderer::getInstance()->blendingEnable();

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------

	// -------------------------------------------------------------------------
	// Načtení textur

	int logoTextureId = CTextureManager::getInstance()->createTexture(
			"data/textures/ground.jpg", false);
	int wallTexture = CTextureManager::getInstance()->createTexture(
			"data/textures/wall2.png", false);

	int crateTexture = CTextureManager::getInstance()->createTexture(
			"data/textures/crate.jpg", false);

	int boxTexture = CTextureManager::getInstance()->createTexture(
			"data/textures/box.jpg", false);

	int cursorTex = CTextureManager::getInstance()->createTexture(
			"data/textures/normal.png", false);

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------


	// -------------------------------------------------------------------------
	// Nastavení kurzoru
	CCursor* cursor = new CCursor();
	cursor->setDimension(32, 32);
	cursor->setTextureId(cursorTex - 1);

	m_gameObject2DManager->add(cursor);
	m_referencesObject2D[5] = m_gameObject2DManager->getLastInsertID();

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------

	// -------------------------------------------------------------------------
	// Nastavení kurzoru

	CGUILabel* scoreLabel = new CGUILabel();
	scoreLabel->hide();
	scoreLabel->setPosition(50, 550);
	scoreLabel->setString("SCORE: ");
	m_gameObject2DManager->add(scoreLabel);
	m_referencesObject2D[7] = m_gameObject2DManager->getLastInsertID();

	// -------------------------------------------------------------------------
	// -------------------------------------------------------------------------

	// -------------------------------------------------------------------------
	// Level v menu

	CLevel* level = new CLevel();
	level->setTextureId(-5);
	dynamic_cast<CLevel*> (level)->setCrateTexId(crateTexture - 1);
	dynamic_cast<CLevel*> (level)->setBoxTexId(boxTexture - 1);

	dynamic_cast<CLevel*> (level)->setWallTexId(0, logoTextureId - 1);
	dynamic_cast<CLevel*> (level)->setWallTexId(1, wallTexture - 1);
	dynamic_cast<CLevel*> (level)->setWallTexId(2, wallTexture - 1);
	dynamic_cast<CLevel*> (level)->setWallTexId(3, wallTexture - 1);
	dynamic_cast<CLevel*> (level)->setWallTexId(4, wallTexture - 1);

	this->m_gameObject3DManager->add(level);

	m_level = level;

	restartLevel();

	this->initialized = true;

	pause();
}

void CSokobanSceneGame::clear() {
	this->m_gameObject3DManager->clean();
	this->m_gameObject2DManager->clean();

	CTextureManager::getInstance()->clean();

}

void CSokobanSceneGame::updateScene() {

	if (m_fadeIn) {
		m_fadesAnimation.update();

		if (!m_fadesAnimation.isEnd()) {
			CGameObject2D *background = this->getReferencedObject2D(6);
			if (background != NULL) {
				background->setAlpha(255 - m_fadesAnimation.getCurrentFrame());
			}
		} else {
			m_fadesAnimation.reset();
			m_fadeIn = false;

			if(!this->m_endOfGame){
				updateScoreLabel();
				play();
				showScore();
			}
		}
	}

	if (m_fadeOut) { // ztmaveni

		hideScore();

		m_fadesAnimation.update(); // aktualizace animace

		if (!m_fadesAnimation.isEnd()) { // pokud neni konec animace
			CGameObject2D *background = this->getReferencedObject2D(6); // vezmeme objekt pozadi
			if (background != NULL) {
				background->setAlpha(m_fadesAnimation.getCurrentFrame()); // snizime ji jas
			}
		} else {

			if (m_goToMenu) {
				goToMenu();
			}

			if (m_nextLevel) {
				nextLevel();
			}

			m_fadesAnimation.reset(); // jinak resetujeme animaci
			m_fadeOut = false; // vypneme priznak ztmaveni
		}

	}

}

// eventy

void CSokobanSceneGame::goToMenu() {
	m_goToMenu = false;
	this->m_running = false;
}

void CSokobanSceneGame::resume() {
	hideCursor();
	hideMenu();
	play();
}

void CSokobanSceneGame::nextLevel() {

	prepareLevel();
	m_fadeIn = true;
	m_fadesAnimation.play();

}

// resulty

void CSokobanSceneGame::resultGoToMenu(bool result) {

	cout << "END" << endl;

	if (result) {
		m_goToMenu = true;
		m_fadeOut = true;
		m_fadesAnimation.play();

	} else {
		showMenu();
	}

	hideConfGoToMenu();
}

void CSokobanSceneGame::resultExitApp(bool result) {
	if (result) {
		SokobanGame::getInstance()->terminate();
	}

	showMenu();
	hideConfExitApp();
}

void CSokobanSceneGame::resultNextLevel(bool result) {

	if (result) {
		m_fadeOut = true;
		m_nextLevel = true;
		m_fadesAnimation.play();

		CProfileManager* pm = CProfileManager::getInstance();
		pm->addActiveProfileScore( getActualScore() );
		pm->setActiveProfileLevelUp();

	} else {
		restartLevel();
	}

	hideConfNextLevel();
	hideMenu();
	hideCursor();
}

void CSokobanSceneGame::restartLevel() {
	hideMenu();
	hideCursor();
	play();
	prepareLevel();
	updateScoreLabel();
}

// pozadavky

void CSokobanSceneGame::requestExitApp() {
	showConfExitApp();
	hideMenu();
}

void CSokobanSceneGame::requestGoToMenu() {
	showConfGoToMenu();
	hideMenu();
}

void CSokobanSceneGame::requestNextLevel() {
	showCursor();
	showConfNextLevel();
	hideMenu();
}

// ovladani

void CSokobanSceneGame::keyboardSpecial(int key, int x, int y) {

	if (!isPaused()) {

		if (m_level != NULL) {
			switch (key) {
			case GLUT_KEY_LEFT:
				m_level->moveActorTo(-1, 0);
				break;

			case GLUT_KEY_RIGHT:
				// actor go RIGHT if he can
				m_level->moveActorTo(1, 0);
				break;

			case GLUT_KEY_UP:
				// actor go UP if he can
				m_level->moveActorTo(0, -1);
				break;

			case GLUT_KEY_DOWN:
				// actor go DOWN if he can
				m_level->moveActorTo(0, 1);
				break;
			}
		}

		if (m_level->isFinished()) {
			this->requestNextLevel();
		}

		updateScoreLabel();
	}
}

void CSokobanSceneGame::keyboard(unsigned char key, int x, int y) {

	if ((int) key == 27) {
		pause();
		showMenu();
		showCursor();
	}
}

void CSokobanSceneGame::setLevel(int id) {

	cout << "LOAD LEVEL " << id << endl;

	// nacteni levelu ze souboru
	CLevelLoader* ll = CLevelLoader::getInstance();

	if (ll->loadLevel(id)) {
		ll->put(*(m_level));
	} else {
		m_level->hide();
		showMessEndGame();
		showCursor();
		hideScore();
		m_endOfGame = true;
	}
}

void CSokobanSceneGame::showScore() {
	showSceneObject2D(7);
}

void CSokobanSceneGame::showConfNextLevel() {
	showSceneObject2D(2);
}

void CSokobanSceneGame::showConfExitApp() {
	showSceneObject2D(1);
}

void CSokobanSceneGame::showConfGoToMenu() {
	showSceneObject2D(0);
}

void CSokobanSceneGame::showMenu() {
	showSceneObject2D(4);
}

void CSokobanSceneGame::showCursor() {
	this->showSceneObject2D(5);
}

void CSokobanSceneGame::showMessEndGame() {
	hideScore();
	showSceneObject2D(3);
}

void CSokobanSceneGame::hideConfNextLevel() {
	hideSceneObject2D(2);
}

void CSokobanSceneGame::hideConfExitApp() {
	hideSceneObject2D(1);
}

void CSokobanSceneGame::hideConfGoToMenu() {
	hideSceneObject2D(0);
}

void CSokobanSceneGame::hideMenu() {
	hideSceneObject2D(4);
}

void CSokobanSceneGame::hideMessEndGame() {
	hideSceneObject2D(3);
}

void CSokobanSceneGame::hideCursor() {
	this->hideSceneObject2D(5);
}

void CSokobanSceneGame::hideScore() {
	this->hideSceneObject2D(7);
}

void CSokobanSceneGame::prepareLevel() {
	CProfileManager* pm = CProfileManager::getInstance();
	int iLevel = pm->getActiveProfileLevel();
	this->setLevel(iLevel + 1);
}

void CSokobanSceneGame::updateScoreLabel(){

	CGameObject2D *labelScore = this->getReferencedObject2D(7);
	string strScore("SCORE: ");

	int score = getActualScore();

	if( labelScore != NULL ){
		strScore.append( _toString<int>(score) );
		dynamic_cast<CGUILabel*>(labelScore)->setString( strScore );
	}

}

int CSokobanSceneGame::getActualScore(){
	if( this->m_level != NULL ){
		return m_level->getActorTurns();
	}

	return 0;
}

void CSokobanSceneGame::endGoToMenu(){
	this->resultGoToMenu(true);
}

