/** @file SokobanSceneGame.h
*
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CSokobanSceneGame
 *
 *
 * \brief Scéna - hra
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CSOKOBANSCENEGAME_H_
#define _CSOKOBANSCENEGAME_H_

#include "GameState.h"
#include "Level.h"

#include "Animation.h"

class CSokobanSceneGame: public CGameState {
public:
	CSokobanSceneGame();
	virtual ~CSokobanSceneGame();

	void init();
	void clear();
	void updateScene();

	void keyboard(unsigned char key, int x, int y);
	void keyboardSpecial(int key, int x, int y);

	// --

protected:

	void setLevel(int id);

	void pause() {
		m_pause = true;
	}
	;
	void play() {
		m_pause = false;
	}
	;
	bool isPaused() const {
		return m_pause;
	}
	;

	void prepareLevel();

	void resume();
	void nextLevel();
	void restartLevel();
	void goToMenu();
	void endGoToMenu();

	void resultNextLevel(bool result);
	void resultGoToMenu(bool result);
	void resultExitApp(bool result);

	void requestExitApp();
	void requestGoToMenu();
	void requestNextLevel();

	void showScore();
	void showCursor();
	void showMenu();
	void showMessEndGame();
	void showConfNextLevel();
	void showConfExitApp();
	void showConfGoToMenu();

	void hideCursor();
	void hideMenu();
	void hideMessEndGame();
	void hideConfNextLevel();
	void hideConfExitApp();
	void hideConfGoToMenu();
	void hideScore();

	int  getActualScore();
	void updateScoreLabel();

	bool m_pause;
	CLevel* m_level;

	CAnimation m_fadesAnimation;

	bool m_fadeIn;
	bool m_fadeOut;

	bool m_nextLevel;
	bool m_goToMenu;
	bool m_restartLevel;
	bool m_endOfGame;

};

#endif /* _CSOKOBANSCENEGAME_H_ */
