/** @file Stringable.h
*
* \author František Toman
*
* \version 1.0
*
*/


/**
 * \class CStringable
 *
 *
 * \brief Retězce
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CSTRINGABLE_H_
#define _CSTRINGABLE_H_

#include "main.h"

class CStringable {
public:
	CStringable();
	virtual ~CStringable();

	void setString( string str ){ m_string = str; };
	string getString() const { return m_string; };

	void removeLastChar();
	void append( char ch ){ m_string.append(1, ch); };
	void append( string str ){ m_string.append(str); };
	size_t length(){ return m_string.size(); };

	void setMaxLength( int maxLength ){ m_maxLength = maxLength; };
	int getMaxLength(){ return m_maxLength; };

protected:
	string	m_string;
	int		m_maxLength;
};

#endif /* STRINGABLE_H_ */
