#include "Texture.h"

/** konstruktor
 */
CTexture::CTexture( CImageLoader::ImageInfo info, bool mipmaps ){
	m_ID = createTexture( info, mipmaps );
}

/** destruktor
 */

CTexture::~CTexture(){
	
	if( m_ID ){							// ma-li textura nastaveny odkaz na data v pameti
		glDeleteTextures(1, &m_ID);		// pak tato data smazeme
	}

}

/**
 * Vytvoří texturu z obrázku
 * @param info
 * @return
 */
GLuint CTexture::createTexture( CImageLoader::ImageInfo info, bool mipmaps ){
	
	m_mipmaps = mipmaps;

	GLuint textureID;													// ID textury

	glGenTextures( 1, &textureID );										// vygenerujeme novou texturu
	glBindTexture(GL_TEXTURE_2D, textureID);							//

	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

	// nastavime interpolacni metodu na linearni interpolaci ( no mipmaps )
	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );			// filtrovani pri zvetseni linearni
	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );			// filtrovani pri zmenseni linearni

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);



	// specifikace textury
	glTexImage2D( 	GL_TEXTURE_2D, 						// typ textury
					0, 									// uroven (mipmapping)
					info . format,						// barevna hloubka
					info . width,						// sirka
					info . height,						// vyska
					0,									// sirka ramu
					info . format,		// format obrazku (RGB, RGBA, ..)
					GL_UNSIGNED_BYTE,					// typ dat obrazku
					info . data						// data obrazku

	);

	return textureID;
}

