/** @file Texture.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CTexture
 *
 *
 * \brief Textura
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CTEXTURE_H_
#define _CTEXTURE_H_

#include "main.h"
#include "ImageLoader.h"

class CTexture {

public:
	CTexture(CImageLoader::ImageInfo info, bool mipmaps); // konstruktor
	~CTexture(); // destruktor
	GLuint createTexture(CImageLoader::ImageInfo info, bool mipmaps); // nacteni textury

	GLuint getID() const {
		return m_ID;
	}
	; // vrati ID textury

	bool mipmaps(void) const {
		return m_mipmaps;
	}
	;

private:
	GLuint m_ID;
	bool m_mipmaps;

};

#endif

