#include "TextureManager.h"


/** Vytvori texturu z nacteneho obrazku
 */

int CTextureManager::createTexture( const char *fileName, bool mipmaps ){
	
	m_imageLoader = CImageLoader::getInstance();		// inicializace nacitace obrazku

	if( m_imageLoader -> loadImage( fileName ) ){							// 	zkusime nacist do pameti obrazek
		CTexture* newTexture = new CTexture( m_imageLoader -> getInfo(), mipmaps );	// vytvorime texturu
		add( newTexture );
		return size();														// vratime index v poli (ukladaji si vykreslovatelne objekty)
	}

	return -1;
}

/** Vrati ID textury na danem indexu
 */

GLuint CTextureManager::getTextureID( int index ){
	
	if( index >= m_size ){
		return 0;
	}

	CTexture*	texture = get( index ); 

	if( texture == NULL ){
		return 0;
	}

	return texture -> getID();
}

