/** @file TextureManager.h
 *
 * \author František Toman
 *
 * \version 1.0
 *
 */

/**
 * \class CTextureManager
 *
 *
 * \brief Správce textur
 *
 *
 * \author František Toman
 *
 * \version 1.0
 *
 *
 * Kontakt: tomanfra@fit.cvut.cz
 *
 */

#ifndef _CTEXMAN_H_
#define _CTEXMAN_H_

#include "ImageLoader.h"
#include "Texture.h"
#include "Collection.h"

class CTextureManager: public CSingleton<CTextureManager> , public CCollection<
		CTexture> {

public:

	int createTexture(const char *fileName, bool mipmaps); // pridani textury
	GLuint getTextureID(int index); // vrátí ID textury v paměti

protected:
	CImageLoader* m_imageLoader; // načítač obrázků

};

#endif

