/*
 * Textureable.cpp
 *
 *  Created on: May 19, 2011
 *      Author: franta
 */

#include "Textureable.h"

/**
 * Konstruktor
 */
CTextureable::CTextureable() {
	m_textureId = -1;				// ID textury, která je uložena ve správci textur (TextureManager)
	this->m_countVertices = 0;		// počet vrcholů textury
	this->m_texCoord = NULL;		// vrcholy textury
}

/**
 * Destruktor
 */
CTextureable::~CTextureable() {
	clean();
}

/**
 * Nastavení souřadnic textury
 * @param vertices - vrcholy
 * @param count - pocet vrcholu
 */
void CTextureable::setVertices(GLfloat* vertices, int count) {
	clean(); // uvolneni prostredku
	init(count); // inicializace novych prosredku

	for( int i = 0; i < count; i++ ){
		m_texCoord[i] = vertices[ i ];		// zkopírování pole vertices
	}
}

/** Uvolneni prostredku
 */
void CTextureable::clean() {
	if (m_texCoord != NULL) {		// jsou-li prostředky alokovány, pak je smaž
		delete[] m_texCoord;		// smazání dosavadních prostředků
		m_texCoord = NULL;
		m_countVertices = 0;		// počet vrcholů = 0
	}
}

/**
 * Inicializace prostředků
 * @param count - velikost alokovaných prostředků
 */
void CTextureable::init(int count) {
	m_texCoord = new GLfloat[count];	// alokování paměti jednorozměrného dynamického pole
	m_countVertices = count;		// nastavení počtu vrcholů textury

	// inicializace jednorozmerneho dynamickeho pole
	for (int i = 0; i < count; i++) {
		m_texCoord[i] = 0;
	}
}
